//Audio.cpp
#include "Audio.h"
// MAKE SURE TO SEARCH FOR "MIX" BECAUSE I THINK I THREW IN A MIX_PLAYCHANNEL() SOMEWHERE ON ACCIDENT
//SEARCH FOR IT AND ERASE IT
void Audio::Init()
{
	//set our format to 16 bit
	Uint16 format = AUDIO_S16SYS; 
    
	//start up sdl_mixer and play at 44khz with 16 bit sound, 2 challels and 4096 chunk size
	Mix_OpenAudio(44100,format,2,4096);//or 2048?2048

	//load the chunks and music
	die = Mix_LoadWAV("sounds/sfx/donkey.wav");
	explode = Mix_LoadWAV("sounds/sfx/explode.wav");
	
	eat = Mix_LoadWAV("sounds/sfx/crunch3.wav");
	//eat[1] = Mix_LoadWAV("sounds/sfx/crunch3.wav");
    //eat[2] = Mix_LoadWAV("sounds/sfx/crunch.wav");

	drop_bomb = Mix_LoadWAV("sounds/sfx/drop_bomb.wav");
	pick_up = Mix_LoadWAV("sounds/sfx/pick_up.wav");

	punch = Mix_LoadWAV("sounds/sfx/punch.wav");
	
    button_hover = Mix_LoadWAV("sounds/sfx/buttonhover.wav");
	button_push = Mix_LoadWAV("sounds/sfx/buttonpush.wav");
	stretch = Mix_LoadWAV("sounds/sfx/stretch.wav");

	page = Mix_LoadWAV("sounds/sfx/pageturn.wav");
	youwin = Mix_LoadWAV("sounds/sfx/youwin.wav");
	warp = Mix_LoadWAV("sounds/sfx/warp.wav");

	intro_music = Mix_LoadMUS("sounds/music/music.mid");
	level1 = Mix_LoadMUS("sounds/music/level1.mid");
	level2 = Mix_LoadMUS("sounds/music/level2.mid");
	level3 = Mix_LoadMUS("sounds/music/level3.mid");
	level4 = Mix_LoadMUS("sounds/music/level4.mid");
	level5 = Mix_LoadMUS("sounds/music/level5.mid");
	gameover = Mix_LoadMUS("sounds/music/gameover2.mid");
	
	

	//allocate 8 channels
	Mix_AllocateChannels(8);

	//lower the volume to half of what its default is (128) this is because
	//the sound fx over-power the music -1 means do this for all channels

}

void Audio::Play(Sound SOUND)
{
	static int c = 0;
	
	switch (SOUND)
	{
	
	case DIE:
		Mix_PlayChannel(-1,die,0);
		break;

	case EXPLODE:
		Mix_PlayChannel(-1,explode,0);
		break;

	case EAT:
		Mix_PlayChannel(-1,eat,0);
		break;

	case DROP_BOMB:
		Mix_PlayChannel(-1,drop_bomb,0);
		break;

	case PUNCH:
		Mix_PlayChannel(-1,punch,2);
		break;

	case PICK_UP:
		Mix_PlayChannel(-1,pick_up,0);
		break;
		
	case PAGE:
		Mix_PlayChannel(-1,page,0);
		break;

	case BUTTON_HOVER:
		Mix_PlayChannel(-1,button_hover,0);
		break;

	case BUTTON_PUSH:
		Mix_PlayChannel(-1,button_push,0);
		break;

	case STRETCH:
		Mix_PlayChannel(-1,stretch,0);
		break;
		
	case YOUWIN:
		Mix_PlayChannel(-1,youwin,0);
		break;

	case WARP:
		Mix_PlayChannel(-1,warp,0);
		break;

	case MUS_INTRO:
		Mix_PlayMusic(intro_music,5);
		//Mix_VolumeMusic(16); 
		//Mix_Volume(-1,120); 
		break;

	case MUS_LEVEL1:
		Mix_PlayMusic(level1,5);
		break;
	
	case MUS_LEVEL2:
		Mix_PlayMusic(level2,5);
		break;
		
	case MUS_LEVEL3:
		Mix_PlayMusic(level3,5);
		break;
	
	case MUS_LEVEL4:
		Mix_PlayMusic(level4,5);
		break;
	
	case MUS_LEVEL5:
		Mix_PlayMusic(level5,5);
		break;

	case MUS_GAMEOVER:
		Mix_PlayMusic(gameover,1);
		break;



	}
}

void Audio::Stop_Music()
{
	Mix_HaltMusic();
	/*
	switch (MUSIC)
	{

	case MUS_INTRO:
		Mix_HaltMusic();
		Mix_FreeMusic(intro_music);
		break;
	}
*/
}

void Audio::Close()
{
	//deallocate channels
	Mix_AllocateChannels(0);

	//free the chunks
	Mix_FreeChunk(explode);
	Mix_FreeChunk(die);

    Mix_FreeChunk(eat);

	Mix_FreeChunk(drop_bomb); 
	Mix_FreeChunk(pick_up);

	Mix_FreeChunk(punch); 
	
    Mix_FreeChunk(button_hover); 
	Mix_FreeChunk(button_push);
	Mix_FreeChunk(stretch);
	Mix_FreeChunk(youwin);

	Mix_FreeChunk(page);
	Mix_FreeChunk(warp);
	
	//stop the music, and free the music, then close SDL mixer
	
	Mix_HaltMusic();
	Mix_FreeMusic(intro_music);
	Mix_FreeMusic(level1);
	Mix_FreeMusic(level2);
	Mix_FreeMusic(level3);
	Mix_FreeMusic(level4);
	Mix_FreeMusic(level5);
	Mix_FreeMusic(gameover);

	
	Mix_CloseAudio();

}
    



	

