//Entity.cpp
#include "Entity.h"
Entity::Entity(int start_direction, int start_mode,int ID)
{
	direction = start_direction; 
	mode = start_mode;
	death_spin = 0; //init death_spin to 0 (had to happen somewhere, huh?)
	int update_counter = 0;
	changing_states = false;
	ammo = 0;
	score = 0;
	lives = 3;
	this->ID = ID;
	warps = 3;
}

int Entity::Get_xPos()
{
	return xPos;
}

void Entity::Set_xPos(int xPos)
{
	this->xPos = xPos;
}

int Entity::Get_yPos()
{
	return yPos;
}

void Entity::Set_yPos(int yPos)
{
	this->yPos = yPos;
}

int Entity::Get_Dir()
{
	return direction;
}

void Entity::Set_Dir(int dir)
{
	direction = dir;
}

int Entity::Get_Mode()
{
	return mode;
}

void Entity::Set_Mode(int mode)
{
	this->mode = mode;
}

void Entity::Move_Up()
{
	yPos-=4;
}

void Entity::Move_Down()
{
	yPos+=4;
}

void Entity::Move_Left()
{
	xPos-=4;
}

void Entity::Move_Right()
{
	xPos+=4;
}




void Entity::Load_Base(SpriteBase *base, SDL_Surface *screen,SpriteBase *grey,SpriteBase *white) //this initializes our classes base to the base we want
//ie this assigns our set of frames (spritebase) to the entity we specify
//ex  player.Init_Frame(&player_base)
{
  Sprite_Base = base;			//the base we sent in now equals the base for this entity
  this->screen = screen;		//the screen we sent in is the screen we draw on
  Grey_Base = grey;				//the grey and white sprite frames
  White_Base = white;
  //start at the first frame and show grey first when going into scared mode
  Frame_Count = 0;
  show_grey = true;
}


void Entity::Draw()
{
	
	//the time so that the next frame is drawn every 250 milliseconds
	//when the time has passed, we increment frame_count (so at the end of this function
	//we draw the next frame). if we get passed frame 3, we go back to 0.
  

	if(ID == PLAYER)
		Delay = 80;
	else Delay = 200;

	if(SDL_GetTicks() > Last_Update + Delay)
    {
       //increment to the next frame
	  Frame_Count++;
	
	  if (Frame_Count > 2)
		  Frame_Count = 0;

      Last_Update = SDL_GetTicks();
    }
  
	//make a Rect for where we are going to draw this entity
	SDL_Rect entity_location;
	entity_location.x = xPos;
	entity_location.y = yPos;
 
	//now we draw the current frame, depending on which direction were going and what 
	//Frame_Count is at
  


	switch (direction)
  {
	case GO_UP:
		 SDL_BlitSurface(Sprite_Base->North_Frame[Frame_Count], NULL,screen, &entity_location); 
		break;

	case GO_DOWN:
		SDL_BlitSurface(Sprite_Base->South_Frame[Frame_Count], NULL,screen, &entity_location); 
		break;

	case GO_LEFT:
		SDL_BlitSurface(Sprite_Base->West_Frame[Frame_Count], NULL,screen, &entity_location); 
		break;

	case GO_RIGHT:
		SDL_BlitSurface(Sprite_Base->East_Frame[Frame_Count], NULL,screen, &entity_location); 
		break;

	case STOP:
		SDL_BlitSurface(Sprite_Base->West_Frame[Frame_Count],NULL,screen,&entity_location);
		break;
  }

  

}//end of Entity::Draw()


void Entity::Draw_Player_Dead()
{
	
	//if 200 ms passed show the next frame
		if(SDL_GetTicks() > Last_Update + 150)
    {
       //increment to the next frame
	  death_spin++;
	
	  if (death_spin > 3)
		  death_spin = 0;

      Last_Update = SDL_GetTicks();
    }
  
	//make a Rect for where we are going to draw this entity
	SDL_Rect entity_location;
	entity_location.x = xPos;
	entity_location.y = yPos;
	
	switch (death_spin)
		{

		case 0:
			 SDL_BlitSurface(Sprite_Base->North_Frame[0], NULL,screen, &entity_location); 
			break;

		case 1:
			SDL_BlitSurface(Sprite_Base->South_Frame[0], NULL,screen, &entity_location); 
			break;

		case 2:
			SDL_BlitSurface(Sprite_Base->West_Frame[0], NULL,screen, &entity_location); 
			break;

		case 3:
			SDL_BlitSurface(Sprite_Base->East_Frame[0], NULL,screen, &entity_location); 
			break;
		}

	
}//end of Draw_Death()

void Entity::Draw_Scared()
{
	
	if(SDL_GetTicks() > Last_Update + 200)
    {
       //increment to the next frame
	  Frame_Count++;
	
	  if (Frame_Count > 2)
		  Frame_Count = 0;

      Last_Update = SDL_GetTicks();
    }
  
	//make a Rect for where we are going to draw this entity
	SDL_Rect entity_location;
	entity_location.x = xPos;
	entity_location.y = yPos;
 
	//now we draw the current frame, depending on which direction were going and what 
	//Frame_Count is at
  

if (show_grey)
{
	switch (direction)
  {
	case GO_UP:
		 SDL_BlitSurface(Grey_Base->North_Frame[Frame_Count], NULL,screen, &entity_location); 
		 show_grey = false;
		 break;

	case GO_DOWN:
		SDL_BlitSurface(Grey_Base->South_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = false;
		break;

	case GO_LEFT:
		SDL_BlitSurface(Grey_Base->West_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = false;
		break;

	case GO_RIGHT:
		SDL_BlitSurface(Grey_Base->East_Frame[Frame_Count], NULL,screen, &entity_location); 
	    show_grey = false;	
		break;

	case STOP:
		SDL_BlitSurface(Grey_Base->West_Frame[Frame_Count],NULL,screen,&entity_location);
		show_grey = false;
		break;
  }

}
else	//else show grey was false, so show white
{
		switch (direction)
  {
	case GO_UP:
		 SDL_BlitSurface(White_Base->North_Frame[Frame_Count], NULL,screen, &entity_location); 
		 show_grey = true;
		 break;

	case GO_DOWN:
		SDL_BlitSurface(White_Base->South_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case GO_LEFT:
		SDL_BlitSurface(White_Base->West_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case GO_RIGHT:
		SDL_BlitSurface(White_Base->East_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case STOP:
		SDL_BlitSurface(White_Base->West_Frame[Frame_Count],NULL,screen,&entity_location);
		show_grey = true;
		break;
  }

}//end of else show grey was false



}//end of draw_scared()


void Entity::Draw_Enemy_Dead()
{

	
	//the enemies death sequence is weak, he just moves randomly
	if(death_spin < 20)
	{
		xPos+=15;
		yPos-=15;
	}

	else if(death_spin < 40)
	{
		xPos-=15;
		yPos-=15;
	}

	else if(death_spin  < 60)
	{
		xPos-=15;
		yPos+=15;
	}

	else 
	{
		xPos+=15;
		yPos+=15;
	}

	//collision
	if(xPos < 0)
		xPos = 768;
	else if (xPos > 800)
		xPos = 0;

	if(yPos < 32)
		yPos = 568;
	else if (yPos > 568)
		yPos = 32;

	//after 100 frames the death sequence is over
	//put the enemy back in there spot, set to standby for 100 frames then go to active
	


	//make a Rect for where we are going to draw this entity
	SDL_Rect entity_location;
	entity_location.x = xPos;
	entity_location.y = yPos;
 
	//now we draw the current frame, depending on which direction were going and what 
	//Frame_Count is at
  

if (show_grey)
{
	switch (direction)
  {
	case GO_UP:
		 SDL_BlitSurface(Grey_Base->North_Frame[Frame_Count], NULL,screen, &entity_location); 
		 show_grey = false;
		 break;

	case GO_DOWN:
		SDL_BlitSurface(Grey_Base->South_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = false;
		break;

	case GO_LEFT:
		SDL_BlitSurface(Grey_Base->West_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = false;
		break;

	case GO_RIGHT:
		SDL_BlitSurface(Grey_Base->East_Frame[Frame_Count], NULL,screen, &entity_location); 
	    show_grey = false;	
		break;

	case STOP:
		SDL_BlitSurface(Grey_Base->West_Frame[Frame_Count],NULL,screen,&entity_location);
		show_grey = false;
		break;
  }

}
else	//else show grey was false, so show white
{
		switch (direction)
  {
	case GO_UP:
		 SDL_BlitSurface(White_Base->North_Frame[Frame_Count], NULL,screen, &entity_location); 
		 show_grey = true;
		 break;

	case GO_DOWN:
		SDL_BlitSurface(White_Base->South_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case GO_LEFT:
		SDL_BlitSurface(White_Base->West_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case GO_RIGHT:
		SDL_BlitSurface(White_Base->East_Frame[Frame_Count], NULL,screen, &entity_location); 
		show_grey = true;
		break;

	case STOP:
		SDL_BlitSurface(White_Base->West_Frame[Frame_Count],NULL,screen,&entity_location);
		show_grey = true;
		break;
  }

}//end of else show grey was false

	


	death_spin++;

	if (death_spin > 250) //after weve done this for 100 frames, we end the enemies death sequence
	{
		xPos = start_x;		//first we set this enemies coordinates to their original ones
		yPos = start_y;
		Set_State(STANDBY,100,ACTIVE); //we set there mode to STANDBY for 100 frames, then back to ACTIVE
	   
		//give random chance of starting out going right or left
		int random = rand()%2;
		if(random == 0)
			direction = GO_LEFT;
		else direction = GO_RIGHT;

		death_spin = 0; //reset death_spin to 0 for the next time they die. VERY IMPORTANT!!!!!
	}
  

}//end of draw enemy dead


void Entity::Update_State()
{
	//if we are currently switching states  
	if (changing_states)
	{
		update_counter--;   //decrease timeout by one, effectively doing a count-down untill the state-change 
	
		if (update_counter <= 0) //if we reached 0, its time to state change       
		{
			mode = next_mode;         //change state
			changing_states = false;  //flip state changing to off
		}
	}

}

void Entity::Set_State(int STATE1,int TIME,int STATE2)
{
	changing_states = true;  //flip state changing to on so it will update inside Update_State
	update_counter = TIME;     
	mode = STATE1;    
	next_mode = STATE2;
}

void Entity::Render()
{
	//if the players dead, draw him dead.
    if (mode == P_DEAD)
	    Draw_Player_Dead();

	//if this enemy is dead, draw him dead
	else if (mode == E_DEAD)
		Draw_Enemy_Dead();
	
	//else if this enemy scared, draw him scared
	else if (mode == SCARED)
		Draw_Scared();
		
	//else if none of the above is true, then draw this entity as normal
	else Draw();				
		
}//end of Render()
