#include "leveledit.h"

//this structure holds all of the non animated sprites and the done variable
data data;		

const int WALLS[MAX_WALLS] = {20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35}; 

//array of walls, should be in Tile_Types  but enums cant be arrays
//start a pointer that points to the keys being pressed
Uint8* keys;

int current_tile = WALLS[6]; //the current tile the user has selected

int last_tile = WALLS[6];
//the map will first draw in Init_Map(). later is changes as we eat food in Collide()
//all change-able pieces(ie food) are re-drawn each frame in Draw_Backgrounds() 

int map[19][25] = 
{{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},			
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};


int main(int argc, char *argv[])
{
  
    int time = 0;				    //init time
	
    InitSDL();					    //standard SDL init crap
  
    InitImages();				    //load the images for the map about to be drawn

	bool flip = false;
	

	while(data.done == 0) //main game loop, while we havent quit (done stays 0 till we x out)
	{
	
		 time = SDL_GetTicks();					//for FPS limiter

		
		 Draw_Map();

		 
		 Take_Input();							//poll for input and exiting key presses
	
		 
	  static int counter = 0;
	  counter++;
	  //this counter and if statement will make it so we only can scroll through tiles every other frame
	if(counter % 2 == 0)
	  {
		 
		 if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
			Change_Tile();
	

		else if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(2))
		{
			current_tile++;
			//this will skip 12 - 17 because these tiles are OPEN_CK_ETC and should not be used in the map maker
			if(current_tile == 12)
				current_tile = 17;

			if (current_tile > 36)
				current_tile = 0;

		}

		else if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3))
		{
			current_tile--;

			//this skips 12 - 17 because there NOT USED IN THE MAP MAKER
			if(current_tile == 16)
				current_tile = 11;

			if (current_tile < 0)
				current_tile = 36;
		
		}
    	  
	  }//end counter % 2 == 0
	  
		 Draw_Selected();

		 SDL_Flip(data.screen);

		while (SDL_GetTicks() - time < 1000/20);			//15 fps limiters
	
	} //main game loop
 
  
	return 0;

}




//locks the screen

void Lock_Screen(SDL_Surface *screen)			 //this locks the screen
{
  if ( SDL_MUSTLOCK(screen) )					//if we have to lock the screen
  {
    if ( SDL_LockSurface(screen) < 0 )			 //then lock it
    {
      return;
    }
  }
}

//unlocks the screen

void Unlock_Screen(SDL_Surface *screen)				//this unlocks the screen
{
  if ( SDL_MUSTLOCK(screen) )						//if we have to lock the screen
  {  
    SDL_UnlockSurface(screen);					    //then unlock it
  }
}

//loads the bitmaps and turns them into pointers

int InitImages() 
{
    data.open_space = IMG_Load("open_space.jpg");
	
	data.walls[0] = IMG_Load("images/walls/wallhorz1a.bmp");
	data.walls[1] = IMG_Load("images/walls/wallhorz2a.bmp");
	data.walls[2] = IMG_Load("images/walls/wallvert1a.bmp");
	data.walls[3] = IMG_Load("images/walls/wallvert2a.bmp");
	data.walls[4] = IMG_Load("images/walls/green.bmp");
	data.walls[5] = IMG_Load("images/walls/rippled.bmp");
	data.walls[6] = IMG_Load("images/walls/seam1.bmp");
	data.walls[7] = IMG_Load("images/walls/seam2.bmp");
	data.walls[8] = IMG_Load("images/walls/seam3.bmp");
	data.walls[9] = IMG_Load("images/walls/seam4.bmp");
	
	data.walls[10] = IMG_Load("images/walls/greene.bmp");
	data.walls[11] = IMG_Load("images/walls/greens.bmp");
	data.walls[12] = IMG_Load("images/walls/greenn.bmp");
	data.walls[13] = IMG_Load("images/walls/greenw.bmp");
	data.walls[14] = IMG_Load("images/walls/seam6.bmp");
	data.walls[15] = IMG_Load("images/walls/seam7.bmp");


	data.door = IMG_Load("images/misc/door.bmp");
	
	//entity images
	data.player = IMG_Load("images/player/E1.bmp");
	data.red_enemy = IMG_Load("images/red_enemy/E1.bmp");
	data.purple_enemy = IMG_Load("images/purple_enemy/E1.bmp");
	data.blue_enemy = IMG_Load("images/blue_enemy/E1.bmp");
	data.yellow_enemy = IMG_Load("images/yellow_enemy/E1.bmp");

	data.dynomite = IMG_Load("images/misc/dyno.bmp");

	data.glow_food = IMG_Load("images/misc/food2.bmp");
	data.ball = IMG_Load("images/misc/ball1.bmp");


	data.check_go_north = IMG_Load("images/misc/ck_north.bmp");
	data.check_go_south = IMG_Load("images/misc/ck_south.bmp");
	data.check_go_west = IMG_Load("images/misc/ck_west.bmp");
	data.check_go_east = IMG_Load("images/misc/ck_east.bmp");
	data.warp_intersection = IMG_Load("images/misc/ck_both.bmp");

    SDL_SetColorKey(data.dynomite,SDL_SRCCOLORKEY,SDL_MapRGB(data.dynomite->format, 255, 0, 255));
    SDL_SetColorKey(data.player,SDL_SRCCOLORKEY,SDL_MapRGB(data.player->format, 255, 0, 255));
    SDL_SetColorKey(data.red_enemy,SDL_SRCCOLORKEY,SDL_MapRGB(data.red_enemy->format, 255, 0, 255));
    SDL_SetColorKey(data.purple_enemy,SDL_SRCCOLORKEY,SDL_MapRGB(data.purple_enemy->format, 255, 0, 255));
    SDL_SetColorKey(data.blue_enemy,SDL_SRCCOLORKEY,SDL_MapRGB(data.blue_enemy->format, 255, 0, 255));
    SDL_SetColorKey(data.yellow_enemy,SDL_SRCCOLORKEY,SDL_MapRGB(data.yellow_enemy->format, 255, 0, 255));
	
	return 0;
}

//this the main drawing function which draws everything

void DrawIMG(SDL_Surface *img, int x, int y) 
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL,data.screen, &dest); 
}




void Draw_Map() //this draws the blank spaces over our moving things (gloves and player)
{
     Lock_Screen(data.screen);
  	
	 for (int y = 0; y < 19; y++)
	{	
		for (int x = 0; x < 25; x++)
		{
		
			if(map[y][x] == DOOR)
				DrawIMG(data.door,x*32,y*32);
		
			else if(map[y][x] == FOOD)
				DrawIMG(data.ball,x*32,y*32);

			else if (map[y][x] == OPEN_SPACE)
				DrawIMG(data.open_space,x*32,y*32);

			else if (map[y][x] == PLAYER)
				DrawIMG(data.player,x*32,y*32);

			else if (map[y][x] == RED_ENEMY)
				DrawIMG(data.red_enemy,x*32,y*32);

			else if (map[y][x] == PURPLE_ENEMY)
				DrawIMG(data.purple_enemy,x*32,y*32);
			
			else if (map[y][x] == BLUE_ENEMY)
				DrawIMG(data.blue_enemy,x*32,y*32);
			
			else if (map[y][x] == YELLOW_ENEMY)
				DrawIMG(data.yellow_enemy,x*32,y*32);

			else if (map[y][x] == BOMB)
				DrawIMG(data.dynomite,x*32,y*32);
			
			else if(map[y][x] == WARP_INTERSECTIONS)
				DrawIMG(data.warp_intersection,x*32,y*32);
			
			else if(map[y][x] == CHECK_GO_NORTH)
				DrawIMG(data.check_go_north,x*32,y*32);

			else if(map[y][x] == CHECK_GO_SOUTH)
				DrawIMG(data.check_go_south,x*32,y*32);

			else if(map[y][x] == CHECK_GO_WEST)
				DrawIMG(data.check_go_west,x*32,y*32);

			else if(map[y][x] == CHECK_GO_EAST)
				DrawIMG(data.check_go_east,x*32,y*32);
			
			else if(map[y][x] == GLOWING_FOOD)
				DrawIMG(data.glow_food,x*32,y*32);

			else
			{
				for(int i = 0; i < MAX_WALLS; i++)
				{
					if(map[y][x] == WALLS[i])
						DrawIMG(data.walls[i],x*32,y*32);
				}
			}
						
		}//end of checking the x's (columns)
	}//end of checking the y's (rows)




  Unlock_Screen(data.screen); 
}//end of Draw_Map()



void InitSDL()
{
	//this is standard initialization crap

  if (SDL_Init(SDL_INIT_VIDEO) < 0) 
	  //init the video and if we couldnt, then print out an error
  {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  
  //init the screen as a 800/600 window and if we cant then print out an error
  data.screen = SDL_SetVideoMode(1024,768,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
 
  if ( data.screen == NULL )
  {
    printf("Unable to set 800x600 video: %s\n", SDL_GetError());
    exit(1);
  }

}

 
//change to Clear_Map()
void Clear_Map() //this function loads our map for the first time. it draws our background
//screen, the walls, the floor, the food. it assigns coordinates to the player/enemies 
{
	for(int y = 0; y < 19; y++)
	{
		for(int x = 0; x < 25; x++)
		{
			map[y][x] = OPEN_SPACE;
		}
	}


}//end of Init_Map()


void Change_Tile()
{
	int tempx;
	int tempy;

    SDL_GetMouseState(&tempx, &tempy);    // Get the mouse coords

	if( (tempx < 800 && tempy < 600) && (tempx > 0 && tempy > 0) ) //only change the tile if the user is clicking within the map part of the screen
	{

    int tilecheckx = tempx;
	int tilechecky = tempy;

	int tilecoordx = tempx / 32; //x coordinate, tile-wise, of the PC
	int tilecoordy = tempy / 32; //y coordinate, tile-wise, of the PC
	
	//first we find what tile the user clicked on... then we change that tile to the current tile.
	int temp = tilecoordx;

	bool collision = false;
	
	for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // checking two x's for the first y
	{   			
		map[tilecoordy][tilecoordx] = current_tile;
		return;
	}
	
	tilecoordy++; // point to the second y tile coordinate
	
	if (((tilecoordy * 32) <= (tempy + 31)) && (!collision))
	{	
		tilecoordx = temp; // restore the x	
			
		for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // two more x's for the second y	
		{   		
			map[tilecoordy][tilecoordx] = current_tile;
		    return;

		}//end for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) for the second y	
		
	}//end 	if (((tilecoordy * 32) <= (tempy + 31)) && (!collision))
	

  }//end making sure the user clicked inside the map part of the screen


}//end of Change_Tile()




void Take_Input()
{
	SDL_Event event; //create an event holder

    while ( SDL_PollEvent(&event) ) //looks for events
    {
	  
	  if ( event.type == SDL_QUIT )  {  data.done = 1;  } //if the user pressed the X on the screeen quit

     
	 if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
      {
		  if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
		  { 
			  data.done = 1; //if they pressed escape or q then quit
		  } 

		  if(event.key.keysym.sym == SDLK_SPACE)
		  {
			  Clear_Map();
		  }

		  if(event.key.keysym.sym == SDLK_z)
		  {
			  last_tile = current_tile;
			  current_tile = OPEN_SPACE;
		  }

		  if(event.key.keysym.sym == SDLK_x)
		  {
			  current_tile = last_tile;
		  }
		
		  
		  if(event.key.keysym.sym == SDLK_1)
		  {
			 Save(MAP1);
		  }
		  else if(event.key.keysym.sym == SDLK_2)
		  {
			 Save(MAP2);
		  }
		  else if(event.key.keysym.sym == SDLK_3)
		  {
			 Save(MAP3);
		  }

		  
		  if(event.key.keysym.sym == SDLK_7)
		  {
			  Open("map.txt");
		  }
		  
		  else if(event.key.keysym.sym == SDLK_8)
		  {
			  Open("map2.txt");
		  }
		    
		  else if(event.key.keysym.sym == SDLK_9)
		  {
			  Open("map3.txt");
		  }
				
       
	  }//end of    if ( event.type == SDL_KEYDOWN )

 }//end of   while ( SDL_PollEvent(&event) ) 

    
	keys = SDL_GetKeyState(NULL);

}//end of take input()





void Draw_Selected() //this draws the currently selected tile on the side of the map
{
     Lock_Screen(data.screen);
  	
			
		   if(current_tile == DOOR)
				DrawIMG(data.door,850,300);
		
			else if(current_tile == FOOD)
				DrawIMG(data.ball,850,300);

			else if (current_tile == OPEN_SPACE)
				DrawIMG(data.open_space,850,300);

			else if (current_tile == PLAYER)
				DrawIMG(data.player,850,300);

			else if (current_tile == RED_ENEMY)
				DrawIMG(data.red_enemy,850,300);

			else if (current_tile == PURPLE_ENEMY)
				DrawIMG(data.purple_enemy,850,300);
			
			else if (current_tile == BLUE_ENEMY)
				DrawIMG(data.blue_enemy,850,300);
			
			else if (current_tile == YELLOW_ENEMY)
				DrawIMG(data.yellow_enemy,850,300);

			else if (current_tile == BOMB)
				DrawIMG(data.dynomite,850,300);
			
			else if(current_tile == WARP_INTERSECTIONS)
				DrawIMG(data.warp_intersection,850,300);
			
			else if(current_tile == CHECK_GO_NORTH)
				DrawIMG(data.check_go_north,850,300);

			else if(current_tile == CHECK_GO_SOUTH)
				DrawIMG(data.check_go_south,850,300);

			else if(current_tile == CHECK_GO_WEST)
				DrawIMG(data.check_go_west,850,300);

			else if(current_tile == CHECK_GO_EAST)
				DrawIMG(data.check_go_east,850,300);
			
			else if(current_tile == GLOWING_FOOD)
				DrawIMG(data.glow_food,850,300);

			else
			{
				for(int i = 0; i < MAX_WALLS; i++)
				{
					if(current_tile == WALLS[i])
						DrawIMG(data.walls[i],850,300);
				}
			}


  Unlock_Screen(data.screen); 
}

void Save(Map MAP)
{
	ofstream fout;										// Here we create an ofstream and we will call it "fout", like "cout".

	if(MAP == MAP1)
	 fout.open("map.txt");
	
	else if(MAP == MAP2)
		fout.open("map2.txt");
	
	else if(MAP == MAP3)
		fout.open("map3.txt");

  for(int y = 0; y < 19; y++)
	{
		for(int x = 0; x < 25; x++)
		{
			fout << map[y][x] << ' ';
		}

	}

														// close() closes the file for us. (very important)
	fout.close();
}

void Open(string MAP)
{

	
	ifstream file_in(MAP.c_str());

	// Error Check
	if(!file_in)
		return;

	for(int y = 0; y < 19; y++)
	{
		for(int x = 0; x < 25; x++)
		{
			file_in >> map[y][x];
		}

	}
				


   file_in.close();
		
	

}//end of open()
