#ifndef LEVELEDIT_H
#define LEVELEDIT_H

#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "SDL_image.lib")
#endif

#include <stdio.h>
#include <stdlib.h>
//#include <windows.h>
#include <fstream>	 //for save and open
#include <iostream>
using namespace std;
#include "SDL.h"
#include "SDL_image.h"

//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"") 
//get rid of that ugly console window

enum Map
{
	MAP1,
	MAP2,
	MAP3
};

enum Tile_Types
{
 OPEN_SPACE, //0
 DOOR,

 PLAYER,
 RED_ENEMY, 
 PURPLE_ENEMY,
 BLUE_ENEMY, //5
 YELLOW_ENEMY,

 WARP_INTERSECTIONS,  //intersections for enemy AI
 CHECK_GO_NORTH, 		//more intersection
 CHECK_GO_SOUTH,	  //more intersection
 CHECK_GO_WEST,//10
 CHECK_GO_EAST,
 
 //12 THROUGH 16 ARE NOT USED IN THE MAP MAKER BUT KEPT HERE TO MAINTAIN CONSITENCY WITH THE GAME ENUMS
 
 OPEN_CK_NORTH,//12	
 OPEN_CK_SOUTH,		
 OPEN_WARP,
 OPEN_CK_WEST,//15
 OPEN_CK_EAST,//16
 
 FOOD, 
 GLOWING_FOOD,	//tiles to open spaces, but STILL be intersections. there fore there is 2 types
 
 BOMB,//19

 //now const int walls[10] takes up 22-whatever
};		



const int MAX_WALLS = 16;

struct data         //data is the struct which holds all of our images used in Init_Map and Draw_Backgrounds()
{
	public:

	data()
	{done = 0;}
	~data()
	{
		//free our surfaces on our way out
		SDL_FreeSurface(open_space);
		SDL_FreeSurface(dynomite);
		SDL_FreeSurface(door);
		SDL_FreeSurface(glow_food);
	    SDL_FreeSurface(ball);

		SDL_FreeSurface(player);
		SDL_FreeSurface(red_enemy);
		SDL_FreeSurface(purple_enemy);
		SDL_FreeSurface(blue_enemy);
		SDL_FreeSurface(yellow_enemy);
		

		for(int i = 0; i < MAX_WALLS; i++)
			SDL_FreeSurface(walls[i]);
	}

	SDL_Surface *screen;
	
	SDL_Surface *open_space;
	
	SDL_Surface *walls[16];
	
	SDL_Surface *door;


	
	//entity images
	SDL_Surface *player;
	SDL_Surface *red_enemy;
	SDL_Surface *purple_enemy;
	SDL_Surface *blue_enemy;
	SDL_Surface *yellow_enemy;



	SDL_Surface *dynomite;

	SDL_Surface *glow_food;
	SDL_Surface *ball;

	//none of these are freed in the destructor 
	SDL_Surface *check_go_north;
	SDL_Surface *check_go_south;
	SDL_Surface *check_go_west;
	SDL_Surface *check_go_east;
	SDL_Surface *warp_intersection;

    int done;							//when this equals 0 the game ends

};



void Lock_Screen(SDL_Surface *screen); //this locks the screen

void Unlock_Screen(SDL_Surface *screen); //this unlocks the screen

void InitSDL();

int InitImages(); //this loads the bmps and converts them to pointers

void Init_Map();

void Draw_Map();

void Take_Input();

void Change_Tile();

void DrawIMG(SDL_Surface *img, int x, int y); 

void Select_Tile();

void Clear_Map();

void Draw_Selected(); //this draws the blank spaces over our moving things (gloves and player)

void Save(Map MAP);

void Open(string MAP);

#endif 



