#include "main.h"
#include "Entity.h"
#include "SpriteBase.h"
#include "Bomb.h"
#include "Messages.h"
#include "Audio.h"
//#include "Bomb.h"

//lets make our entity's, initializing there starting direction
Entity player(STOP,ACTIVE,PLAYER); 
Entity red_enemy(GO_UP,ACTIVE,RED_ENEMY);
Entity purple_enemy(GO_RIGHT,STANDBY,PURPLE_ENEMY);
Entity blue_enemy(GO_LEFT,STANDBY,BLUE_ENEMY);
Entity yellow_enemy(GO_RIGHT,STANDBY,YELLOW_ENEMY);

//lets make a spritebase for each one of the entities
SpriteBase player_base;
SpriteBase red_enemy_base;
SpriteBase purple_enemy_base;
SpriteBase blue_enemy_base;
SpriteBase yellow_enemy_base;

//now the 2 spritebases for when there scared
SpriteBase grey_base;
SpriteBase white_base;

Audio sound;

//this structure holds all of the non animated sprites and the done variable
data data;		

vector <Bomb> bomb;
int init_bombs = 0;

//we init data.screen but data.screen isnt valid untill InitSDL... fix: init the screen in data's constructor!
Messages message; //a holder for our messages

//start a pointer that points to the keys being pressed
Uint8* keys; 

//a counter for doing the death sequence. ie the player spins around for 35 frames then everything goes back to normal
int dead_alive_switch = 0;

//the map will first draw in Init_Map(). later is changes as we eat food in Collide()
//the entire map is re-drawn each frame in Draw_Backgrounds() 
//we init it here just incase something went wrong in the Load_Level() function
int map[19][25] = 
{{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},			
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};

//timers to draw time passed for board

int start_time = 0;
int time_passed = 0;

int old_lives = 0;
int old_bombs = 0;
int old_score = 0;
int old_warps = 0;

//timers we need global so Messages::Next_Level() can use them


void Lock_Screen(SDL_Surface *screen); //this locks the screen

void Unlock_Screen(SDL_Surface *screen); //this unlocks the screen

void InitSDL();

int InitImages(); //this loads the bmps and converts them to pointers


void Init_Entities();
void Move_Gloves(Entity &enemy);
void Draw_Entity();
		
void Draw_Backgrounds();

void Move_Pac();

int Hit_Intersection(int tempx,int tempy);
	
bool Entity_Collision(Entity &player, Entity &enemy);

void Do_Death_Sequence();

void Player_Enemy_Death();

bool Collide(int tempx, int tempy);

void Switch_Direction(Entity &enemy);

bool Bomb_Hit(Entity &enemy,Bomb &bomb);

void Draw_Bombs();

void Draw_Score();
	
int main(int argc, char *argv[])
{

  int time = 0;				    //init time
	
  InitSDL();					//standard SDL init crap
    
  InitImages();				    //load the images for the map about to be drawn

  sound.Init();					//init our sound system
  
  message.Init();
  
  Init_Entities();				//load the frames into bases and bases into entities

 // message.You_Win();
  message.Show_Intro();			//do the intro screen
  
  //message.Next_Level();

  Load_Level();					//load the first level


	while(data.done == 0) //main game loop, while we havent quit (done stays 0 till we x out)
	{
		
		///record the players lives/ammo/score so later we can see if it changed in Draw_Score()
		 old_lives = player.lives;
		 old_bombs = player.ammo;
		 old_score = player.score;
		 old_warps = player.warps;
		 
	     time = SDL_GetTicks();					//for FPS limiter

		 if (data.food_count == 0)				//if we eat all the food
		 {
			 //load the next level
			 if(data.current_level < 5)
				 Load_Level();
			 else message.You_Win();
		 } 
		 
		 Draw_Backgrounds();					//first draw the background over the old objects
				 
		 Take_Input();							//poll for input and exiting key presses
	
		
		 if(player.Get_Mode() == ACTIVE)		//now move the enemy and player but only if player is alive
		{	
			Move_Pac();

			if(red_enemy.Get_Mode() != E_DEAD)
				Move_Gloves(red_enemy);
			
			if(purple_enemy.Get_Mode() != E_DEAD)
				Move_Gloves(purple_enemy);

			if(blue_enemy.Get_Mode() != E_DEAD)
				Move_Gloves(blue_enemy);

			if(yellow_enemy.Get_Mode() != E_DEAD)
				Move_Gloves(yellow_enemy);
		}
		
		 else if(player.Get_Mode() == P_DEAD)		//if the player had just died,do the death sequence
			Do_Death_Sequence();			
	
		 
		Player_Enemy_Death();	//check for enemy/player/bomb collision and set modes to dead if approriate
								//this is the function where ALL death is handled

		red_enemy.Update_State();
		purple_enemy.Update_State();
		blue_enemy.Update_State();
		yellow_enemy.Update_State();

		Draw_Bombs();				//draw and manage the bombs

		message.Update_Message();	//draw a message if its in the que
		
		Draw_Score();

		Draw_Entity();				//now draw the Entitys in there positions and flip the screen

		if(player.lives <= 0)
			message.Game_Over();

		
		//SDL_Delay(0);

		while (SDL_GetTicks() - time < 1000/35);			//30 fps limiters
	
	} //main game loop
 
  
	sound.Close();					//close the sound system!

	return 0;

}




//locks the screen

void Lock_Screen(SDL_Surface *screen)			 //this locks the screen
{
  if ( SDL_MUSTLOCK(screen) )					//if we have to lock the screen
  {
    if ( SDL_LockSurface(screen) < 0 )			 //then lock it
    {
      return;
    }
  }
}

//unlocks the screen

void Unlock_Screen(SDL_Surface *screen)				//this unlocks the screen
{
  if ( SDL_MUSTLOCK(screen) )						//if we have to lock the screen
  {  
    SDL_UnlockSurface(screen);					    //then unlock it
  }
}

//loads the bitmaps and turns them into pointers

int InitImages() 
{

	data.walls[0] = Load_Image("images/walls/wallhorz1a.bmp");
	data.walls[1] = Load_Image("images/walls/wallhorz2a.bmp");
	data.walls[2] = Load_Image("images/walls/wallvert1a.bmp");
	data.walls[3] = Load_Image("images/walls/wallvert2a.bmp");
	data.walls[4] = Load_Image("images/walls/green.bmp");
	data.walls[5] = Load_Image("images/walls/rippled.bmp");
	data.walls[6] = Load_Image("images/walls/seam1.bmp");
	data.walls[7] = Load_Image("images/walls/seam2.bmp");
	data.walls[8] = Load_Image("images/walls/seam3.bmp");
	
	data.walls[9] = Load_Image("images/walls/seam4.bmp");
    data.walls[10] = Load_Image("images/walls/greene.bmp");
	data.walls[11] = Load_Image("images/walls/greens.bmp");
	data.walls[12] = Load_Image("images/walls/greenn.bmp");
	data.walls[13] = Load_Image("images/walls/greenw.bmp");
	data.walls[14] = Load_Image("images/walls/seam6.bmp");
	data.walls[15] = Load_Image("images/walls/seam7.bmp");

 
    data.glow_food[0] = Load_Image("images/misc/food2.bmp");
    data.glow_food[1] = Load_Image("images/misc/food3.bmp");
    data.glow_food[2] = Load_Image("images/misc/food4.bmp");
    data.glow_food[3] = Load_Image("images/misc/food5.bmp");

    //init glow count to 0, therefore start drawing at the first frame of the food
    data.glow_counter = 0;

    data.ball[0] = Load_Image("images/misc/ball1.bmp");
    data.ball[1] = Load_Image("images/misc/ball2.bmp");
    data.ball[2] = Load_Image("images/misc/ball3.bmp");
    data.ball[3] = Load_Image("images/misc/ball4.bmp");
    data.ball[4] = Load_Image("images/misc/ball5.bmp");

		
    //load the dynomite images and set there magenta transparency
    data.dynomite = Load_Image("images/misc/dyno.bmp");
    data.boom = Load_Image("images/misc/boom.bmp");
    data.boom2 = Load_Image("images/misc/boom2.bmp");

    data.door = Load_Image("images/misc/door.bmp");
    data.open_space = Load_Image("images/misc/open_space.jpg");

	data.blank_sheet = Load_Image("images/misc/blank_sheet.bmp");

    SDL_SetColorKey(data.dynomite, SDL_SRCCOLORKEY,SDL_MapRGB(data.dynomite->format, 255, 0, 255));
    SDL_SetColorKey(data.boom, SDL_SRCCOLORKEY,SDL_MapRGB(data.boom->format, 255, 0, 255));
    SDL_SetColorKey(data.boom2, SDL_SRCCOLORKEY,SDL_MapRGB(data.boom2->format, 255, 0, 255));

	return 0;
}

//this the main drawing function which draws everything

void DrawIMG(SDL_Surface *img, int x, int y) 
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL, data.screen, &dest); 
}

void DrawBG(SDL_Surface *img,int dx,int dy,int w,int h)
{
	
	SDL_Rect dest;
	dest.x = dx;
	dest.y = dy;

	//our BG image
	SDL_Rect slice;
	slice.x = dx;
	slice.y = dy;
	slice.w = w;
	slice.h = h;

	SDL_BlitSurface(img, &slice, data.screen, &dest);
}






void Draw_Backgrounds() //this draws the blank spaces over our moving things (gloves and player)
{
  Lock_Screen(data.screen);
  
  //this holds which element of the ball[] array to draw. its incremented each frame and resets to 0 after 4 (there is 4 frames)
  static int bcount = 0;
  static bool counting_up = true;
  //what we do here is re-draw each walk-able tile each frame. this is so pacman can eat the food
  //when he walks over a food tile, that tile changes to an open space tile. so we have to re-draw these parts
  //of the map each frame. theres 2 types of walkable tiles - food and open space. 
  //but there are different types of food and open space tiles. there is regular food/openspace
  //and there is intersection food/open space. regardless of what type is stored in the array
  //we draw only 1 or 2 images - either the food image or the open space image.
  
  for (int y = 1; y<19; y++)
	{	
		for (int x=0;x<25;x++) //we start y at one because the whole top row we dont want to re-draw
								//because this top row is where all the text is drawn
								//and we dont re-draw text each frame
		{

	    	 if (map[y][x] == FOOD || map[y][x] == WARP_INTERSECTIONS || 
				 map[y][x] == CHECK_GO_NORTH || map[y][x] == CHECK_GO_SOUTH ||
				 map[y][x] == CHECK_GO_WEST || map[y][x] == CHECK_GO_EAST ||
				 map[y][x] == PLAYER)
					DrawIMG(data.ball[bcount],x*32,y*32);

			else if (map[y][x] == OPEN_SPACE || map[y][x] == OPEN_WARP || 
				map[y][x] == OPEN_CK_SOUTH || map[y][x] == OPEN_CK_NORTH  ||
			    map[y][x] == OPEN_CK_WEST || map[y][x] == OPEN_CK_EAST ||
				map[y][x] == PURPLE_ENEMY || map[y][x] == RED_ENEMY || map[y][x] == BLUE_ENEMY
				|| map[y][x] == YELLOW_ENEMY)
					DrawIMG(data.open_space,x*32,y*32);

			else if (map[y][x] == GLOWING_FOOD)
				DrawIMG(data.glow_food[data.glow_counter],x*32,y*32);
				
			else if(map[y][x] == DOOR)
				DrawIMG(data.door,x*32,y*32);
			
			else if(map[y][x] == BOMB)
			{
				//if the bomb was picked up, draw an open space where the bomb was
				for(int i = 0; i < bomb.size(); i++)
				{
					//if(bomb[i].state != WAITING)
					map[y][x] = OPEN_SPACE;
				}
			}
			
			else //else it must have been a wall . now we draw the walls
			{
				//loop through each wall untill we find the right one
				for(int j = 0; j < MAX_WALLS; j++)
				{
					if(map[y][x] == WALLS[j])
						DrawIMG(data.walls[j],x*32,y*32);
				}
			}
		

		}//end of checking the x's (columns)
	
	}//end of checking the y's (rows)

		//for the animated food in the corners
		data.glow_counter++;
		
		if(data.glow_counter > 3)
			data.glow_counter = 0;

		if(counting_up)
			bcount++;
		else bcount--;
		
		if(bcount == 4 || bcount == 0)
		{
			counting_up = !counting_up;
		}

		Unlock_Screen(data.screen); 
}


void Draw_Entity() //this draws the moving things (gloves and player)
{				
  Lock_Screen(data.screen);//lock the screen for drawing

  player.Render();			//draw the player ALWAYS

  if(player.Get_Mode() != P_DEAD)  //only draw the enemies if the player is alive
  {
  red_enemy.Render();

  purple_enemy.Render();

  blue_enemy.Render();

  yellow_enemy.Render();
  }

  SDL_Flip(data.screen); //this draws everything to the screen at once
  
  Unlock_Screen(data.screen); //this unlocks the screen
}


void InitSDL()
{

	
	if (SDL_Init(SDL_INIT_VIDEO) < 0) 
	  //init the video and if we couldnt, then print out an error
	 {
		 printf("Unable to init SDL: %s\n", SDL_GetError());
		 exit(1);
	  }
	  atexit(SDL_Quit);

 
  SDL_WM_SetIcon(IMG_Load("images/misc/icon.bmp"),NULL); //sets the icon in the window
 
  //init the screen as a 800/600 window and if we cant then print out an error
  #ifdef FULLSCREEN
	 data.screen=SDL_SetVideoMode(800,600,0,SDL_SWSURFACE|SDL_HWPALETTE|SDL_FULLSCREEN);
  #else
	data.screen=SDL_SetVideoMode(800,600,0,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_ANYFORMAT);
  #endif
  
	//if(bpp == 32)
  //thiso one   data.screen=SDL_SetVideoMode(800,600,0,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_ANYFORMAT); //);//  SDL_SWSURFACE|SDL_HWPALETTE|SDL_FULLSCREEN|   
  // else  if(bpp == 24)
  //data.screen=SDL_SetVideoMode(800,600,24,SDL_HWSURFACE|SDL_DOUBLEBUF); //);//     
   //else data.screen=SDL_SetVideoMode(800,600,16,SDL_HWSURFACE|SDL_DOUBLEBUF); //);//  SDL_SWSURFACE|SDL_HWPALETTE|SDL_FULLSCREEN|   
  

  if ( data.screen == NULL )
  {
    printf("Unable to set 800x600 video: %s\n", SDL_GetError());
    exit(1);
  }

  
  SDL_WM_SetCaption("Donkey Punch Adventure - A Donkey Punch Production",NULL); //set the caption in the window

}

 
void Move_Pac() //does all movement/collision detection for the player
{
	//now we take input, and based on that input we decide which direction were going to move in
	//	BUT WE DONT SWITCH DIRECTIONS UNLESS WE ARE NOT GOING TO COLLIDE, OTHERWISE THE MOVEMENT
	// WILL BE STICKY AND NOT SMOOTH 

	if (keys[SDLK_UP])
	{
		if (!Collide(player.Get_xPos(),player.Get_yPos() - 4) )
			player.Set_Dir(GO_UP);
	}
	

	 if (keys[SDLK_DOWN])
	 {
		if (!Collide(player.Get_xPos(),player.Get_yPos() + 4) )
			player.Set_Dir(GO_DOWN);
	 }

	 if (keys[SDLK_LEFT])
	 {
		if (!Collide(player.Get_xPos() - 4,player.Get_yPos()) )
		 player.Set_Dir(GO_LEFT);
	 }


	 if (keys[SDLK_RIGHT])
	 {
		if (!Collide(player.Get_xPos() + 4,player.Get_yPos()) )
		 player.Set_Dir(GO_RIGHT);
	 }


	//now we check what direction the player is going, based on that direction we try to move

switch (player.Get_Dir())
{

	case GO_UP: 
					
		if (!Collide(player.Get_xPos(),player.Get_yPos() - 4) )
			player.Move_Up();


		break;
	
	case GO_DOWN: 
		
		if (!Collide(player.Get_xPos(),player.Get_yPos() + 4) )
			player.Move_Down();

		break;

	case GO_LEFT: 	
		
		if (!Collide(player.Get_xPos() - 4,player.Get_yPos()) )
		    player.Move_Left();

		break;
	

	case GO_RIGHT: 	
		
		if (!Collide(player.Get_xPos() + 4,player.Get_yPos()) )
			 player.Move_Right();


		break;

	case STOP: 
		player.Set_xPos(player.Get_xPos());
		player.Set_yPos(player.Get_yPos());
		break;

}//end of case (player.direction)


//warp tunnels
if (player.Get_xPos() < 0)
{
	player.Set_xPos(768);
}
else if (player.Get_xPos() > 767)
{
	player.Set_xPos(0);
}


} //end of Move_Pac()




void Init_Map() //this function loads our map for the first time. it draws our background
//screen, the walls, the floor, the food. it assigns coordinates to the player/enemies 

{
	//we set data.food_count to 0 in case it isnt allready... 
	//(it WONT be 0 when this function gets called in Game_Over() and the player will get a game over,
	//then he will eat all the food and be stuck in the level!
	
	data.food_count = 0;
	
	int bc = 0; // the bomb count, used when we find a BOMB a little further down....
	
	//if this isnt the first time we called this function and theres no bombs in it anyway...
	if(!bomb.empty());
		bomb.clear();	//clear out the old bombs to start out with new ones

	for (int y = 0; y < 19; y++)
	{	
		for (int x=0; x< 25; x++)
		{
			
			if(map[y][x] == DOOR)
				DrawIMG(data.door,x*32,y*32);
		
			else if (map[y][x] == FOOD || map[y][x] == WARP_INTERSECTIONS || map[y][x] == CHECK_GO_NORTH || map[y][x] == CHECK_GO_SOUTH || map[y][x] == CHECK_GO_EAST || map[y][x] == CHECK_GO_WEST)
			{
				DrawIMG(data.ball[0],x*32,y*32);
				data.food_count++;
			}

			else if (map[y][x] == OPEN_SPACE)
				DrawIMG(data.open_space,x*32,y*32);

			else if (map[y][x] == PLAYER)
			{
				player.Set_xPos(x*32);
				player.Set_yPos(y*32);
				player.start_x = x*32;
				player.start_y = y*32;
				player.Set_Dir(STOP);
			}

			else if (map[y][x] == RED_ENEMY)
			{
				red_enemy.Set_xPos(x*32);
				red_enemy.Set_yPos(y*32);
				red_enemy.start_x = x*32;
				red_enemy.start_y = y*32;
			}

			else if (map[y][x] == PURPLE_ENEMY)
			{
				purple_enemy.Set_xPos(x*32);
				purple_enemy.Set_yPos(y*32);
				purple_enemy.start_x = x*32;
				purple_enemy.start_y = y*32;
				purple_enemy.Set_Dir(GO_RIGHT);
			}
			
			else if (map[y][x] == BLUE_ENEMY)
			{
				blue_enemy.Set_xPos(x*32);
				blue_enemy.Set_yPos(y*32);
				blue_enemy.start_x = x*32;
				blue_enemy.start_y = y*32;
				purple_enemy.Set_Dir(GO_LEFT);
			}
			
			else if (map[y][x] == YELLOW_ENEMY)
			{
				yellow_enemy.Set_xPos(x*32);
				yellow_enemy.Set_yPos(y*32);
				yellow_enemy.start_x = x*32;
				yellow_enemy.start_y = y*32;
				purple_enemy.Set_Dir(GO_RIGHT);
			}
			
			else if (map[y][x] == BOMB)
			{
						
				//draw an open space where a bomb is
				DrawIMG(data.open_space,x*32,y*32);

				bomb.push_back(Bomb());

				//set this bombs position
				bomb[bc].xPos = bomb[bc].startx = x*32;
				bomb[bc].yPos = bomb[bc].starty = y*32;
				bomb[bc].state = WAITING;
			
				//increment to the next bomb
				bc++;
		
			}
			
			else //else it must have been a wall . now we draw the walls
			{
				//loop through each wall untill we find the right one
				for(int j = 0; j < MAX_WALLS; j++)
				{
					if(map[y][x] == WALLS[j])
						DrawIMG(data.walls[j],x*32,y*32);
				}
			}

		
			
		
		}//end of checking the x's (columns)
	}//end of checking the y's (rows)

}//end of Init_Map()

//should have been (Entity &entity, Directions dir)
bool Collide(int tempx, int tempy)
{
	int tilecheckx = tempx;
	int tilechecky = tempy;

	int tilecoordx = tempx / 32; //x coordinate, tile-wise, of the PC
	int tilecoordy = tempy / 32; //y coordinate, tile-wise, of the PC
	bool collision = false;
	
	//so it basically checks all numbers between the coordinate and the coordinate + 31
	//it checks between all of these to see if any of them has the value of WALL
	//if that fails, then it increases the tilecoordy by one, and tries again
	
	int temp = tilecoordx;
	
	for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // checking two x's for the first y
	{   	
	
			
		if(map[tilecoordy][tilecoordx] >= WALLS[0] && map[tilecoordy][tilecoordx] <= WALLS[MAX_WALLS - 1] )
		{			
			collision = true;
			break;    	
		}
	
		//else if it wasnt a wall, we check  if it was the player using this function. 
		//if it was, we switch that tile to an empty space, effectively making him eat the food
		else if((tilecheckx == player.Get_xPos() + 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() - 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos() + 4)|| 
			tilecheckx == player.Get_xPos() + 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos() - 4 ||
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos())
		{
			//now that we know the player walked into a food tile, we have to change it
			//to an open space tile, but there are  6 types of open spaces,
			//regular ones, and 1 for each of the 5 intersection types
			//if we didnt do this, then when pacman eats food or walks over an intersection
			//it would turn it into an open space and the enemies would lose there AI because 
			//a "check_go_x" tile is changed to open space when the player eats it
			//therefore, there has to be 2 types of intersections - those that display an open space
			//and those that display food.
			
			     //DONT LET THE PLAYER WALK INTO THE ENEMIES BOX
			    if(map[tilecoordy][tilecoordx] == DOOR)
				{
					collision = true;
					break;
				}
			
			    else if (map[tilecoordy][tilecoordx] == WARP_INTERSECTIONS)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_WARP;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_NORTH)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_NORTH;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_SOUTH)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_SOUTH;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_WEST)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_WEST;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_EAST)
				{
					sound.Play(EAT);
				    data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_EAST;
				}
				
				else if (map[tilecoordy][tilecoordx] == FOOD || map[tilecoordy][tilecoordx] == PLAYER)
				{
					if(map[tilecoordy][tilecoordx] == FOOD)
					{
						data.food_count--;
						player.score+=10;
						sound.Play(EAT);

					}

					map[tilecoordy][tilecoordx] = OPEN_SPACE;

				
				}

				else if (map[tilecoordy][tilecoordx] == GLOWING_FOOD)
				{
					//now make the enemies scared for 150 frames, but only if there NOT DEAD
					if(red_enemy.Get_Mode() == ACTIVE)
						red_enemy.Set_State(SCARED,150,ACTIVE);
			
					if (purple_enemy.Get_Mode() == ACTIVE)
						purple_enemy.Set_State(SCARED,150,ACTIVE);
				
					if (blue_enemy.Get_Mode() == ACTIVE)
						blue_enemy.Set_State(SCARED,150,ACTIVE);
						
					if (yellow_enemy.Get_Mode() == ACTIVE )
						yellow_enemy.Set_State(SCARED,150,ACTIVE);
					

					//now change this glowing food into an open space
					map[tilecoordy][tilecoordx] = OPEN_SPACE;
				
				}//end else if glowing food

		}//end big nasty else if

	}//end for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // checking two x's for the first y
	
	
	tilecoordy++; // point to the second y tile coordinate
	
	if (((tilecoordy * 32) <= (tempy + 31)) && (!collision))
	{	
		tilecoordx = temp; // restore the x	
			
		for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // two more x's for the second y	
		{   		

			if(map[tilecoordy][tilecoordx] >= WALLS[0] && map[tilecoordy][tilecoordx] <= WALLS[MAX_WALLS - 1] )
			{				
				collision = true;        			
				break;
			}
			//the following UGLY if statement, is how pacman eats the food.
			//the first else if checks if pacman walked ontop of ANYTHING BESIDES A WALL
			//if this is true - it then has another block of 4 if statements-
			//it checks WHICH tile we walked on. if it was a regular food tile, we switch this
			//to an open space. if it was an intersection tile, we switch this to an open space
			//intersection tile
			else if((tilecheckx == player.Get_xPos() + 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() - 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos() + 4)|| 
			tilecheckx == player.Get_xPos() + 4 && tilechecky == player.Get_yPos() || 
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos() - 4 ||
			tilecheckx == player.Get_xPos() && tilechecky == player.Get_yPos())
		{
			//now that we know the player walked into a food tile, we have to change it
			//to an open space tile, but there are  4 types of open spaces,
			//regular ones, and 1 for each of the 3 intersection types
			//if we didnt do this, then when pacman eats food or walks over an intersection
			//it would turn it into an open space and the enemies would lose there AI
			
			    
			   if(map[tilecoordy][tilecoordx] == DOOR)
				{
					collision = true;
					break;
				}
			        
			    else if (map[tilecoordy][tilecoordx] == WARP_INTERSECTIONS)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_WARP;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_NORTH)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_NORTH;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_SOUTH)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_SOUTH;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_WEST)
				{
					sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_WEST;
				}

				else if(map[tilecoordy][tilecoordx] == CHECK_GO_EAST)
				{
				    sound.Play(EAT);
					data.food_count--;
					player.score+=10;
					map[tilecoordy][tilecoordx] = OPEN_CK_EAST;
				}
				
				else if (map[tilecoordy][tilecoordx] == FOOD || map[tilecoordy][tilecoordx] == PLAYER)
				{
					if(map[tilecoordy][tilecoordx] == FOOD)
					{
						sound.Play(EAT);
						data.food_count--;
						player.score+=10;
	
					}
					
					map[tilecoordy][tilecoordx] = OPEN_SPACE;
				}
				
				else if (map[tilecoordy][tilecoordx] == GLOWING_FOOD)
				{
					//now make the enemies scared for 150 frames, but only if there NOT DEAD
					if(red_enemy.Get_Mode() == ACTIVE)
						red_enemy.Set_State(SCARED,150,ACTIVE);
			
					if (purple_enemy.Get_Mode() == ACTIVE)
						purple_enemy.Set_State(SCARED,150,ACTIVE);
				
					if (blue_enemy.Get_Mode() == ACTIVE)
						blue_enemy.Set_State(SCARED,150,ACTIVE);
						
					if (yellow_enemy.Get_Mode() == ACTIVE )
						yellow_enemy.Set_State(SCARED,150,ACTIVE);
					

					//now change this glowing food into an open space
					map[tilecoordy][tilecoordx] = OPEN_SPACE;
				
				}//end else if glowing food


		}//end if it was the player using this function

		
		}//end for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) for the second y	
		
	}//end 	if (((tilecoordy * 32) <= (tempy + 31)) && (!collision))
	

	return collision;

}//end of Collide


void Move_Gloves(Entity &enemy)
{
	
	
/*//first red_enemy against the other 3
if(Entity_Collision(red_enemy,purple_enemy) && red_enemy.Get_Mode() == ACTIVE && purple_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(red_enemy);
	Switch_Direction(purple_enemy);
}

if(Entity_Collision(red_enemy,blue_enemy) && red_enemy.Get_Mode() == ACTIVE && blue_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(red_enemy);
	Switch_Direction(blue_enemy);
}

if(Entity_Collision(red_enemy,yellow_enemy) && red_enemy.Get_Mode() == ACTIVE && yellow_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(red_enemy);
	Switch_Direction(yellow_enemy);
}


//now purple against the other 2, because above we already did purple with blue
if(Entity_Collision(purple_enemy,blue_enemy) && purple_enemy.Get_Mode() == ACTIVE && blue_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(purple_enemy);
	Switch_Direction(blue_enemy);
}

if(Entity_Collision(purple_enemy,yellow_enemy) && purple_enemy.Get_Mode() == ACTIVE && yellow_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(purple_enemy);
	Switch_Direction(yellow_enemy);
}


//now we have blue enemy against yellow, because blue allready did purple and red
if(Entity_Collision(blue_enemy,yellow_enemy) && blue_enemy.Get_Mode() == ACTIVE && yellow_enemy.Get_Mode() == ACTIVE)
{
	Switch_Direction(blue_enemy);
	Switch_Direction(yellow_enemy);
}
*/
	
	bool collision = false;
	
	//check if were going to collide - if not, then move in the direction we want to

	switch (enemy.Get_Dir())
	{

		case GO_UP:
					
			if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() - 4) )
				 enemy.Move_Up();

			else collision = true;
			
			break;
	
		case GO_DOWN: 

			if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() + 4) )
				enemy.Move_Down();
			
			else collision = true;
			
			break;

		case GO_LEFT: 	
	
			if (!Collide(enemy.Get_xPos() - 4,enemy.Get_yPos()) )
			    enemy.Move_Left();

			else collision = true;

			break;
	

		case GO_RIGHT: 	
	
			if (!Collide(enemy.Get_xPos() + 4,enemy.Get_yPos()) )
				 enemy.Move_Right();
			
			else collision = true;

			break;

		case STOP: 
			enemy.Set_xPos(enemy.Get_xPos());
			enemy.Set_yPos(enemy.Get_yPos());
			
			break;

	}//end of case (enemy direction)


	//now this is the enemy AI - he just moves untill he hits a wall, when he does, he goes in
	//the direction of towards the player. make sure were not standing on an intersection before we change directions
	//this prevents back-tracking (note the Hit_Intersection() == -1 )

	if (collision == true && enemy.Get_Dir() == GO_UP) 
				//if the enemy was going down, he now has to turn right or left
	{
		//now choose to go right or left based on if the player is to the right or left of the enemy
		//if the enemy is scared, we do the opposite thing, ie we go left if the enemy is to the left
		//OR if we are scared and the enemy is to the right
		
		if (player.Get_xPos() < enemy.Get_xPos())	
			//if the player was further to the left then attempt to move left, 
			//failing that you have to go right
		{
			if (!Collide(enemy.Get_xPos() - 4,enemy.Get_yPos()) ) //if were not gunna collide moving left, then go left
				enemy.Set_Dir(GO_LEFT);
		
			else enemy.Set_Dir(GO_RIGHT); //else were colliding so we have to move right
		}
			
		else //the player was further to the right then the enemy, so (try to) move right towards to the player
		{
			if (!Collide(enemy.Get_xPos() + 4,enemy.Get_yPos()) ) //if were not gunna collide moving right, then go right
				enemy.Set_Dir(GO_RIGHT);
		
			else enemy.Set_Dir(GO_LEFT); //else were colliding so we have to move left
		}


	}//end if colliding and going up


// NOW FOR IF THE ENEMY WAS MOVING DOWN AND HE HIT A WALL

	else if (collision == true && enemy.Get_Dir() == GO_DOWN)
			//if the enemy was going down, he now has to turn right or left
	{
		//now choose to go right or left based on if the player is to the right or left of the enemy
		
		if (player.Get_xPos() < enemy.Get_xPos())	
			//if the player was further to the left then attempt to move left, 
			//failing that you have to go right
		{
			if (!Collide(enemy.Get_xPos() - 4,enemy.Get_yPos()) ) //if were not gunna collide moving left, then go left
				enemy.Set_Dir(GO_LEFT);
		
			else enemy.Set_Dir(GO_RIGHT); //else were colliding so we have to move right
		}
			
		else //the player was further to the right then the enemy, so (try to) move right towards to the player
		{
			if (!Collide(enemy.Get_xPos() + 4,enemy.Get_yPos()) ) //if were not gunna collide moving right, then go right
				enemy.Set_Dir(GO_RIGHT);
		
			else enemy.Set_Dir(GO_LEFT); //else were colliding so we have to move left
		}


	}//end if colliding and going down


		
		
		
		else if (collision == true && enemy.Get_Dir() == GO_LEFT)
			//if the enemy was going left, they have to turn up or down
	{


		  	if (player.Get_yPos() < enemy.Get_yPos()) 
				//if the player was higher up then the enemy try to go up, or if that fails go down
			{
				if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() - 4) ) //if we are not going to collide moving up
					enemy.Set_Dir(GO_UP); // move up then
			
				else enemy.Set_Dir(GO_DOWN); //else we collided so we have to go down
			}
			
			else //the player was lower then the enemy so try to go down, or if that fails go up
			{
				if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() + 4) ) //if we are not going to collide moving down
					enemy.Set_Dir(GO_DOWN); //go down
				
				else enemy.Set_Dir(GO_UP); //else we collided so we have to go down
			}
				
		
		//the last thing we do is if the enemy was in standby mode, we have him go right
			//so he bounces left to right
			if(enemy.Get_Mode() == STANDBY)
				enemy.Set_Dir(GO_RIGHT);
		
		
	} //end of collision = true and was going left

	
		
		
		else if (collision == true && enemy.Get_Dir() == GO_RIGHT)
			//if the enemy was going right, they have to turn up or down
	{
		  //now choose to go up or down based on if the enemy is above or below the player
		
			if (player.Get_yPos() < enemy.Get_yPos()) 
				//if the player was higher up then the enemy try to go up, or if that fails go down
			{	
				if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() - 4) ) //if we are not going to collide moving up
					enemy.Set_Dir(GO_UP); // move up then
			
				else enemy.Set_Dir(GO_DOWN); //else we collided so we have to go down
			}
			
			else //the player was lower then the enemy so try to go down, or if that fails go up
			{
				if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() + 4) ) //if we are not going to collide moving down
					enemy.Set_Dir(GO_DOWN); //go down
				
				else enemy.Set_Dir(GO_UP); //else we collided so we have to go down
			}
				
		

		//the last thing we do is if the enemy was in standby mode, we have him go left
		//so he bounces left to right
			if(enemy.Get_Mode() == STANDBY)
				enemy.Set_Dir(GO_LEFT);

	}//end of if collision true and was going right


//if he hits one of the warP spots then warp to the other side

if (enemy.Get_xPos() < 0)
{
	enemy.Set_xPos(768);
}
else if (enemy.Get_xPos() > 767)
{
	enemy.Set_xPos(0);
}


//now we check if the enemy walked into any intersections

//this first one is checking ALL directions... when the enemy walks onto a WARP_INTERSECTION,
//he will "look" in all directions down the corridor, and he will change directions if he "sees" 
//the player... it basically just checks if the x position is == therefore they are in the same hallway
//then the same for y
if ( !collision && Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == WARP_INTERSECTIONS ||
	Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == OPEN_WARP)
{

	if (player.Get_xPos() == enemy.Get_xPos()) //if the player and enemy have the same x position then go up or down
	{								//this is used at intersections by the warpers on the sides
	

		if (player.Get_yPos() < enemy.Get_yPos()) //if the player is higher, move up
		{
			if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() - 4) )
				enemy.Set_Dir(GO_UP);
		}
		else if (player.Get_yPos() >= enemy.Get_yPos()) //if the player is lower, move down
		{
			if (!Collide(enemy.Get_xPos(),enemy.Get_yPos() + 4)  )
				enemy.Set_Dir(GO_DOWN);
		}
	}
	else if (player.Get_yPos() == enemy.Get_yPos()) //else if the player and enemy are on the same y axis, go left or right
	{
		if (player.Get_xPos() < enemy.Get_xPos()) //if the player is more to the left, then go left
		{
			if (!Collide(enemy.Get_xPos() - 4,enemy.Get_yPos()) )
					enemy.Set_Dir(GO_LEFT);
		}
		else if (player.Get_xPos() >= enemy.Get_xPos()) //if the player is more to the right, go right
		{
			if (!Collide(enemy.Get_xPos() + 4,enemy.Get_yPos()) )
				   enemy.Set_Dir(GO_RIGHT);
		}
	}
}

//if we hit an intersection to check to go north, well then check to go north. make sure your not already
//going down (this prevents back-tracking) ALSO, make sure we didnt just collide with a wall.
//this was an un-fixable bug untill i came up with this line (!collision). when a intersection
//would be next to a wall he would collide change directions and then check and then change directions again
//this beutifull little !collision stops this from happening. for more info read "the unfixable bug"
else if (!collision && enemy.Get_Dir() != GO_DOWN && (Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == CHECK_GO_NORTH || 
		 Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == OPEN_CK_NORTH) ) 

{

	 if (player.Get_yPos() < enemy.Get_yPos()) //if  player was higher up then enemy
	{

		//if the enemy isnt going to collide, then go up towards the player
		if(!Collide(enemy.Get_xPos(),enemy.Get_yPos() - 4) ) 
		 enemy.Set_Dir(GO_UP);
	}

}

///same for checking to go south... also make sure your not already going north. this stops the enemy from backtracking
else if ( !collision && enemy.Get_Dir() != GO_UP && (Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == CHECK_GO_SOUTH ||
		 Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == OPEN_CK_SOUTH) )
{
	//if the player was lower then the enemy....
	if (player.Get_yPos() > enemy.Get_yPos())
	{
		//if your not going to collide, then start going down.
		if(!Collide(enemy.Get_xPos(),enemy.Get_yPos() + 4) )
			enemy.Set_Dir(GO_DOWN);
	}
}


///same for checking to go east.. also make sure your not already going west. this stops the enemy from backtracking
else if (!collision && enemy.Get_Dir() != GO_LEFT && (Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == CHECK_GO_EAST ||
		 Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == OPEN_CK_EAST) )
{
	//if the player further to the east then the enemy.
	if (player.Get_xPos() > enemy.Get_xPos())
	{
		//if your not going to collide, then start going east
		if(!Collide(enemy.Get_xPos() + 4,enemy.Get_yPos()) )
			enemy.Set_Dir(GO_RIGHT);
	}
}

///same for checking to go west.. also make sure your not already going east. this stops the enemy from backtracking
else if (!collision && enemy.Get_Dir() != GO_RIGHT && (Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == CHECK_GO_WEST ||
		 Hit_Intersection(enemy.Get_xPos(),enemy.Get_yPos()) == OPEN_CK_WEST) )
{
	//if the player further to the west then the enemy.
	if (player.Get_xPos() < enemy.Get_xPos())
	{
		//if your not going to collide, then start going east
		if(!Collide(enemy.Get_xPos() - 4,enemy.Get_yPos()) )
			enemy.Set_Dir(GO_LEFT);
	}
}
		

	//now lets do something special if there in a special mode

//if the enemy collides with another enemy, reverse.


}//end of Move_Glove




int Hit_Intersection(int tempx,int tempy)
{

	int tilecoordx = tempx / 32; //x coordinate, tile-wise, of the PC
	int tilecoordy = tempy / 32; //y coordinate, tile-wise, of the PC
	bool collision = false;
	
	//so it basically checks all numbers between the coordinate and the coordinate + 31
	//it checks between all of these to see if any of them has the value of WALL
	//if that fails, it then does the same for the y coordinate
	//im guess the first half checks for collisions left and right and the bottom half checks
	//for collision up and down
	int temp = tilecoordx;
	
	for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // checking two x's for the first y
	{   	
		//THESE FIRST 3 ARE THE SAME AS TILES AS THE BOTTOM 3, ACCEPT THAT THE BOTTOM
		//3 ARE AFTER PACMAN ATE THE FOOD,(IE OPEN_SPACE TILE) AND THE FIRST 3 
		//ARE BEFORE HE ATE THE FOOD
		

		//first the intersections with food on them
		if (map[tilecoordy][tilecoordx] == WARP_INTERSECTIONS)    				
		   return WARP_INTERSECTIONS;    	
		 
		else if (map[tilecoordy][tilecoordx] == CHECK_GO_NORTH)
			return CHECK_GO_NORTH;

		else if (map[tilecoordy][tilecoordx] == CHECK_GO_SOUTH)
			return CHECK_GO_SOUTH;

		else if (map[tilecoordy][tilecoordx] == CHECK_GO_WEST)
			return CHECK_GO_WEST;

		else if (map[tilecoordy][tilecoordx] == CHECK_GO_EAST)
			return CHECK_GO_EAST;



		//the open intersections (no food)
		else if (map[tilecoordy][tilecoordx] == OPEN_CK_NORTH)
			return OPEN_CK_NORTH;

		else if (map[tilecoordy][tilecoordx] == OPEN_CK_SOUTH)
			return OPEN_CK_SOUTH;
		
		else if (map[tilecoordy][tilecoordx] == OPEN_WARP)
			return OPEN_WARP;

		else if (map[tilecoordy][tilecoordx] == OPEN_CK_WEST)
			return OPEN_CK_WEST;
		
		else if (map[tilecoordy][tilecoordx] == OPEN_CK_EAST)
			return OPEN_CK_EAST;
		

	}
	
	tilecoordy++; // point to the second y tile coordinate
	
	if (((tilecoordy * 32) <= (tempy + 31)) && (!collision))
	{	
		tilecoordx = temp; // restore the x	
			
		for(tilecoordx; ((tilecoordx * 32) <= (tempx + 31)); tilecoordx++) // two more x's for the second y	
		{   		
			
			if (map[tilecoordy][tilecoordx] == WARP_INTERSECTIONS)    				
				return WARP_INTERSECTIONS;    	
		 
		
			else if (map[tilecoordy][tilecoordx] == CHECK_GO_NORTH)
				return CHECK_GO_NORTH;

			else if (map[tilecoordy][tilecoordx] == CHECK_GO_SOUTH)
				return CHECK_GO_SOUTH;

		
		
		
			else if (map[tilecoordy][tilecoordx] == OPEN_CK_NORTH)
				return OPEN_CK_NORTH;

			else if (map[tilecoordy][tilecoordx] == OPEN_CK_SOUTH)
				return OPEN_CK_SOUTH;
		
			else if (map[tilecoordy][tilecoordx] == OPEN_WARP)
				return OPEN_WARP;
		}
	}
	
//if we got here, then we didnt collide with an intersection. so return -1

	return -1;

}//end of hit_intersection







bool Entity_Collision(Entity &player, Entity &enemy)
{
	int col_width = 32 * 0.60f;
	int col_height = 32 * 0.60f;

	int col_x_offset = (32 - col_width) / 2;
	int col_y_offset = (32 - col_height) / 2;

	int left1, left2;
    int right1, right2;
    int top1, top2;
    int bottom1, bottom2;

    left1 = player.Get_xPos() + col_x_offset;
    left2 = enemy.Get_xPos() + col_x_offset;
    right1 = left1 + col_width;
    right2 = left2 + col_width;
    top1 = player.Get_yPos() + col_y_offset;
    top2 = enemy.Get_yPos() + col_y_offset;
    bottom1 = top1 + col_height;
    bottom2 = top2 + col_height;

    if (bottom1 < top2) 
		return 0;
    if (top1 > bottom2) 
		return 0;
  
    if (right1 < left2) 
		return 0;
    if (left1 > right2) 
		return 0;

    return 1;


};

void Take_Input()
{
	SDL_Event event; //create an event holder

    while ( SDL_PollEvent(&event) ) //looks for events
    {
	  
	  if ( event.type == SDL_QUIT )  {  data.done = 1;  } //if the user pressed the X on the screeen quit

      if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
      {
		  if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
		  { 
			  data.done = 1; //if they pressed escape or q then quit
		  } 

		  if(event.key.keysym.sym == SDLK_p) //if they pressed p then PAUSE the game
		  {
			  message.Pause();  
		  }
			
         //now take bomb input (space bar) ONLY IF THE PLAYER IS NOT DEAD!!!

		 if(player.Get_Mode() != P_DEAD)
		 {
			 //if the player pressed z, hes using the teleport

		   if(player.warps > 0)
		   {

			   if(event.key.keysym.sym == SDLK_z)
			   {
			     do
				 {
					 //set the xPos to random between 0-800
					 player.Set_xPos((rand()%25)*32);
					 
					 //set the yPos to random 0-600, but if its less then 64, make it 64, so we dont wind up in the scoreboard
					 int random_yPos = (rand()%19)*32;
					 
					 if(random_yPos < 64)
						 random_yPos = 64;

					 player.Set_yPos(random_yPos);
				 }
				 while(Collide(player.Get_xPos(),player.Get_yPos()));

				 sound.Play(WARP);

				 //decrease the players warps
				 player.warps--;
			
			 }//end if player pressed z

		   }//end if the player had warps

			 if(event.key.keysym.sym == SDLK_k)
			 {
				 player.Set_Mode(P_DEAD);
				 sound.Play(DIE);
			
			 }
			//if the player pressed space, hes messing with the bomb
			 if( event.key.keysym.sym == SDLK_SPACE)
			{
				//if the bomb is loaded and we have more then 0 bombs then drop a  bomb
				//notice how there is a  break; this makes  it all one decision
				//therefore the player wont blow up/drop all the bombs at once

				//for each bomb
			 for(int i = 0; i < bomb.size(); i++)
			 {
				
				 //FIRST we check if any bombs are dropped, if so detonate them
				 //we do this BEFORE we drop any bombs, so that if we drop a bomb, then pick
				 //another up, it will detonate first bomb when we hit space, instead
				 //of dropping the bomb you just picked up

				 if (bomb[i].state == DROPPED)
				 {
					 sound.Play(EXPLODE);

					 bomb[i].state = BLOWING_UP;
				     break;
				 }

				 else if(bomb[i].state == LOADED && player.ammo > 0)
				{
					sound.Play(DROP_BOMB); 
					
					//this sets the coordinates of the bomb to the players current coordinates
					 //so it gets dropped where the player is
					 bomb[i].Drop(player.Get_xPos(),player.Get_yPos());		
					 bomb[i].state = DROPPED;
					 
					 //decrease players ammo
					 player.ammo--;
					 break;
				 }
			
			 }//end of for loop
			
			 
		  }//end of IF THE PLAYER IS NOT DEAD
			
	   
		}//end of   if( event.key.keysym.sym == SDLK_SPACE)
		
	  }//end of    if ( event.type == SDL_KEYDOWN ) 
   
  }//end of   while ( SDL_PollEvent(&event) ) 
    
	keys = SDL_GetKeyState(NULL);

}//end of take input()

void Do_Death_Sequence()
{
	//dead alive switch starts at 0 before the player dies. when he dies, it increments each frame
	//so, after 35 frames are played (at 15 fps this is a little more then 2 seconds the 
	//player will spin around, the death sequence will bail and the cleanup part will begin
	
	 dead_alive_switch++;
			
			if (dead_alive_switch == 85)
				//after the players spun around for 35 frames, do the cleanup
			{
				//reset the player and all of the entities and the bombs
				
				//sound.Resume(); //turn the background music back on after the death sequence is over

				player.Set_Mode(ACTIVE);
				player.Set_Dir(STOP);
				player.Set_xPos(player.start_x);
				player.Set_yPos(player.start_y);
				player.ammo = 0; 
				player.lives-=1; //lose a life
				player.score -= 150;   //lose 100 poitns when you die!
				
				//reset the bombs to their corners
				for (int i = 0; i < bomb.size(); i++)
				{
				bomb[i].state = WAITING;
				bomb[i].xPos = bomb[i].startx;
				bomb[i].yPos = bomb[i].starty;
				}
				
				red_enemy.Set_xPos(red_enemy.start_x);
				red_enemy.Set_yPos(red_enemy.start_y);
				red_enemy.Set_State(ACTIVE,0,ACTIVE);
			
				purple_enemy.Set_xPos(purple_enemy.start_x);
				purple_enemy.Set_yPos(purple_enemy.start_y);
				purple_enemy.Set_State(STANDBY,50,ACTIVE);
				purple_enemy.Set_Dir(GO_LEFT);
		
				blue_enemy.Set_xPos(blue_enemy.start_x);
				blue_enemy.Set_yPos(blue_enemy.start_y);
				blue_enemy.Set_State(STANDBY,150,ACTIVE);
				blue_enemy.Set_Dir(GO_RIGHT);

				yellow_enemy.Set_xPos(yellow_enemy.start_x);
				yellow_enemy.Set_yPos(yellow_enemy.start_y);
				yellow_enemy.Set_State(STANDBY,250,ACTIVE);
				yellow_enemy.Set_Dir(GO_LEFT);

				//set the switch back to 0 for the next time the player dies
				dead_alive_switch = 0;
			} //end of if dead_alive_switch

}//end of Do_Death_Sequence



void Init_Entities()
{
		
  //lets load all of our frames into our base's
  player_base.Load_Frames(PLAYER);
  red_enemy_base.Load_Frames(RED_ENEMY);
  purple_enemy_base.Load_Frames(PURPLE_ENEMY);
  blue_enemy_base.Load_Frames(BLUE_ENEMY);
  yellow_enemy_base.Load_Frames(YELLOW_ENEMY);
  grey_base.Load_Frames(GREY);
  white_base.Load_Frames(WHITE);
  

  //now lets load all of our base's into our entity's	
  player.Load_Base(&player_base,data.screen,NULL,NULL);
  red_enemy.Load_Base(&red_enemy_base,data.screen,&grey_base,&white_base);
  purple_enemy.Load_Base(&purple_enemy_base,data.screen,&grey_base,&white_base);
  blue_enemy.Load_Base(&blue_enemy_base,data.screen,&grey_base,&white_base);
  yellow_enemy.Load_Base(&yellow_enemy_base,data.screen,&grey_base,&white_base);

}

void Player_Enemy_Death()
{
		 
    //the reason it is one decision and not more then 1 (ie one for each enemy)
	//is this stops the player from killing more then one enemy in a single frame
	//having him kill more then one at a time was causing bugs for some reason
		
   // check if the enemy was scared. if he was, the enemy dies. if not, the player does
			

	//error checking - make sure the player is alive before we kill anybody
	//this way we dont get caught an an infinite death loop of hitting the enemy and dieing, repeat,repeat
		if(player.Get_Mode() == ACTIVE)
		{

			if(Entity_Collision(player,red_enemy) && red_enemy.Get_Mode() == SCARED)
			{
				//we set death_spin to 0 just in case it isnt allready
				//bugs appear if we dont do this....
				red_enemy.death_spin = 0;
		     	red_enemy.Set_State(E_DEAD,0,E_DEAD);
				player.score+=50;
			
			}
		    
			else if (Entity_Collision(player,red_enemy) && red_enemy.Get_Mode() == ACTIVE)
			{
				//again this dead_alive_switch = 0 is just error checking,
				//in a perfect world it *should* be at 0 at this point anyway.....
				dead_alive_switch = 0;
				player.Set_Mode(P_DEAD);
			sound.Play(DIE);
				sound.Play(PUNCH);
			}
		   
			else if(Entity_Collision(player,purple_enemy) && purple_enemy.Get_Mode() == SCARED)
			{   
                  purple_enemy.death_spin = 0; 
				  purple_enemy.Set_State(E_DEAD,0,E_DEAD);
				  player.score+=50;
			}
		   
		    else if (Entity_Collision(player,purple_enemy) && purple_enemy.Get_Mode() == ACTIVE)
			{
				dead_alive_switch = 0;
				player.Set_Mode(P_DEAD);
				sound.Play(DIE);
				sound.Play(PUNCH);
			}
		  
		   
			else if(Entity_Collision(player,blue_enemy) && blue_enemy.Get_Mode() == SCARED)
			{
				blue_enemy.death_spin = 0;
				blue_enemy.Set_State(E_DEAD,0,E_DEAD);
				player.score+=50;
			}
		
		   else if (Entity_Collision(player,blue_enemy) && blue_enemy.Get_Mode() == ACTIVE)
		   {
			   dead_alive_switch = 0;
		   player.Set_Mode(P_DEAD);		  
			  sound.Play(DIE);
			   sound.Play(PUNCH);
		   }
		  
		   
		   else if(Entity_Collision(player,yellow_enemy) && yellow_enemy.Get_Mode() == SCARED)	
		   {
			   yellow_enemy.death_spin = 0;
			   yellow_enemy.Set_State(E_DEAD,0,E_DEAD);
			   player.score+=50;
		   }
			
		   else if (Entity_Collision(player,yellow_enemy) && yellow_enemy.Get_Mode() == ACTIVE)
		   {	
			   dead_alive_switch = 0;
		   player.Set_Mode(P_DEAD);
			  sound.Play(DIE);
			   sound.Play(PUNCH);
		   }
			
		   //the last way that a player/enemy could die, is if a bomb blew them up.
		

			   //now we see if a bomb will hit any of the entities
	
			   for(int i = 0; i < bomb.size(); i++) //loop through all the bombs
			   {
				   if(bomb[i].state == BLOWING_UP)//if a bomb was blowing up, check if it hit an entity, if so kill that person
				   {
					   int death_counter = 0;

						if(Bomb_Hit(red_enemy,bomb[i]))
						{
							red_enemy.Set_State(E_DEAD,0,E_DEAD);
							death_counter++;
							player.score+=15;
						}
				
					    if(Bomb_Hit(purple_enemy,bomb[i]))
						{
							purple_enemy.Set_State(E_DEAD,0,E_DEAD);
							death_counter++;
							player.score+=15;
						}
				
						if(Bomb_Hit(blue_enemy,bomb[i]))
						{
							blue_enemy.Set_State(E_DEAD,0,E_DEAD);
							death_counter++;
							player.score+=15;
						}
				
						if(Bomb_Hit(yellow_enemy,bomb[i]))
						{
							yellow_enemy.Set_State(E_DEAD,0,E_DEAD);
							death_counter++;
							player.score+=15;
						}

						//if we killed 2 enemies or more at once then give an extra life and points and
						//draw "bonus" to the screen
						if(death_counter >= 2)
						{
							static int once = 0;

							if(once == 0)
							{
							message.Set_Message(BONUS,45);
							player.score+=250;
							player.lives++;
							}
							once++;

							if(once == 3)
								once = 0;
						}

						if(Bomb_Hit(player,bomb[i]))
						{
							sound.Play(DIE);
							player.Set_Mode(P_DEAD);
						}
					
				   }//end if bomb[i] == blowing up
			   
			 }//end for loop	
		   
		}//end of error checking making sure player was alive

}//end of Player Enemy Death ()




void Switch_Direction(Entity &enemy)
{
	if(enemy.Get_Dir() == GO_LEFT)
		enemy.Set_Dir(GO_RIGHT);
	else if(enemy.Get_Dir() == GO_RIGHT)
		enemy.Set_Dir(GO_LEFT);
	else if (enemy.Get_Dir() == GO_UP)
		enemy.Set_Dir(GO_DOWN);
	else if (enemy.Get_Dir() == GO_DOWN)
		enemy.Set_Dir(GO_UP);

}


bool Bomb_Hit(Entity &enemy,Bomb &bomb)
{
	//if the player was using this function, DONT do the blast radius
	//this is because we use this function when the player grabs a bomb
	//we dont want him to grab it with a radius
	//this indirectly effects when he blows himself up
	if(enemy.ID == PLAYER)
	{
		int left1, left2;
		int right1, right2;
		int top1, top2;
		int bottom1, bottom2;

		left1 = enemy.Get_xPos();
		left2 = bomb.xPos;
		right1 = enemy.Get_xPos() + 32;
		right2 = bomb.xPos + 32;
		top1 = enemy.Get_yPos();
		top2 = bomb.yPos;
		bottom1 = enemy.Get_yPos() + 32;
		bottom2 = bomb.yPos + 32;

		if (bottom1 < top2) 
			return false;
   
		if (top1 > bottom2) 
			return false;

		 if (right1 < left2) 
			return false;
    
		if (left1 > right2) 
			return false;

		 return true;

	}//end if it was the player using this function
	
	else //else it was an enemy using this... so do the blast radius
	{
	
	float col_width = 32 * 1.1f;
	float col_height = 32 * 1.1f;

	float col_x_offset = (32 - col_width) / 2;
	float col_y_offset = (32 - col_height) / 2;

	int left1, left2;
    int right1, right2;
    int top1, top2;
    int bottom1, bottom2;

    left1 = enemy.Get_xPos() + col_x_offset;
    left2 = bomb.xPos + col_x_offset;
    right1 = left1 + col_width;
    right2 = left2 + col_width;
    top1 = enemy.Get_yPos() + col_y_offset;
    top2 = bomb.yPos + col_y_offset;
    bottom1 = top1 + col_height;
    bottom2 = top2 + col_height;

    if (bottom1 < top2) 
		return false;
   
	if (top1 > bottom2) 
		return false;
  
    if (right1 < left2) 
		return false;
    
	if (left1 > right2) 
		return false;

    return true;

	}

}

void Draw_Bombs() //Draw Bombs is more then just Draw_Bombs.. its also Manage_Bombs() because it manages the bombs current state so does Take_Input()
{
	//now we want to draw the bombs
	for (int j = 0; j < bomb.size(); j++)//change from MAX_BOMBS to player.ammo?
	{
		if(bomb[j].state == WAITING) //if the bomb is waiting to be picked up
		{
			//if the player isnt colliding with it, draw the bomb sitting in its place
			if(!Bomb_Hit(player,bomb[j]))
				DrawIMG(data.dynomite,bomb[j].xPos,bomb[j].yPos);
			
			else  
			{
				sound.Play(PICK_UP);
				//else the player collided with the ammo, effectively picking it up
				//switch bombs state to loaded
				bomb[j].state = LOADED;
				
				//increase ammo count by one
				player.ammo++;
			}
		

		}//end of if waiting
		
		//else DrawIMG(data.open_space,bomb[j].xPos,bomb[j].yPos);//if its not waiting, draw an open space
	
			


		else if(bomb[j].state == DROPPED)
		{
			DrawIMG(data.dynomite,bomb[j].xPos,bomb[j].yPos);
		}

		
	    else if (bomb[j].state == BLOWING_UP)
		{
				//start a counter at 0
				 static int counter = 0;

				 if(counter == 0 || counter == 2) //if its == 0 or 2, draw it blowing up then increment counter(red anim)
				 {
					DrawIMG(data.boom,bomb[j].xPos,bomb[j].yPos);
					counter++;
				 }
				 else if(counter == 1) //if its == 1 draw it blowing up then increment counter (yellow anim)
				 {
					DrawIMG(data.boom2,bomb[j].xPos,bomb[j].yPos);;
					counter++;
				 }
				 else if(counter > 2)		//after 3 frames it resets the bombs state to loaded and the counter to 0 for next time...
				 {
					 bomb[j].state = USED;  //this bombs life is over... set to used
					 counter = 0;			//set the counter to 0 for next time
				 }
		}//end if bomb[j] == blowing_up

	}//end of for j < MAX_BOMBS

}//end of draw_bombs()

void Open(string MAP)
{
	ifstream file_in(MAP.c_str());

	// Error Check
	if(!file_in)
		return;

	for(int y = 0; y < 19; y++)
	{
		for(int x = 0; x < 25; x++)
		{
			file_in >> map[y][x];
		}

	}
				


   file_in.close();
	

}//end of open()

void Load_Level()
{	
    
    //show the "you win" screen but only if we are NOT loading the first level
	if(data.current_level != 0)
		message.Next_Level();

	//increment to the next level
	data.current_level++;

	//now that the in-between level message is done, we start loading in the next level

	//first thing we do is start playing the music for this level

	
	switch(data.current_level)
	{
	
		case 1:
			sound.Play(MUS_LEVEL1);
			break;

		case 2:
			sound.Play(MUS_LEVEL2);
			break;

		case 3:
			sound.Play(MUS_LEVEL3);
			break;

		case 4:
			sound.Play(MUS_LEVEL4);
			break;

		case 5:
			sound.Play(MUS_LEVEL5);
			break;
	}
   

	//set the ammo and score back to 0
	player.ammo = 0;
	player.score = 0;
	player.warps = 3;
	if(player.lives < 3)
		player.lives = 3;
	
	//set the enemies back into standby
    red_enemy.Set_State(ACTIVE,0,ACTIVE);   
	purple_enemy.Set_State(STANDBY,50,ACTIVE);
    blue_enemy.Set_State(STANDBY,100,ACTIVE);
    yellow_enemy.Set_State(STANDBY,150,ACTIVE);

	//our array of map names
	string Levels[5];

	Levels[0] = "level1.txt";
	Levels[1] = "level2.txt";
	Levels[2] = "level3.txt";
	Levels[3] = "level4.txt";
	Levels[4] = "level5.txt";

	//open the level we are on. 
    Open(Levels[data.current_level - 1]);

	//re-set all the coordinates of the players/enemies/food/foodcount/etc.
	Init_Map();

	//start the timer for this level
	start_time = SDL_GetTicks();

}
	

void Draw_Score()
{
	
	if(player.lives < 0)
		player.lives = 0;
	if(player.score < 0)
		player.score = 0;
	if(player.ammo < 0)
		player.ammo = 0;

	//calculate the seconds passed since the level has started
	int time_now = SDL_GetTicks();
    time_passed = (time_now - start_time)/1000;
	
	if(time_passed > 598)
		time_passed = 598;

	if(time_passed < 1)
	{

	//first we draw the text for each item at the top.. this doesnt change so no need for drawing it more then once
	message.Draw_Txt("Time:",488,0,SMALL,LIGHT);
	message.Draw_Txt("Bombs:",175,0,SMALL,LIGHT);
	message.Draw_Txt("Score:",10,0,SMALL,LIGHT);
	message.Draw_Txt("Warps:",665,0,SMALL,LIGHT);
	message.Draw_Txt("Lives:",328,0,SMALL,LIGHT);

	}

	//if the player's score has changed OR the board just started (less then 1 second has passed)... 
	//then update/draw the score

	if(player.score != old_score || time_passed < 1)
	{
		//this will be a buffer to hold our score. we need to send Draw_Txt() a char * not an int
		char score_count[10];
	
		//start a string stream and convert player.score into a string
		stringstream ss;	
		ss << player.score;
		strcpy(score_count, ss.str().c_str());

		//draw "score :"

		//now draw the newly converted score  
	
		DrawBG(data.blank_sheet,95,0,70,32);
		message.Draw_Txt(score_count,95,0,SMALL,LIGHT);
	}

	//if the player's ammo has changed... update/draw the ammo
	if(player.ammo != old_bombs  || time_passed < 1)
	{
		//a buffer but this time for ammo
		char bomb_count[2];
		stringstream ss2;	
		ss2 << player.ammo;
		strcpy(bomb_count, ss2.str().c_str());
	
		DrawBG(data.blank_sheet,275,0,30,32);
		message.Draw_Txt(bomb_count,275,0,SMALL,LIGHT);
    }
		
	//error check, the game will crash if we somehow get less then 0 lives, same probably for all font drawing. apparently
	//ttf cant draw negative numbers, or  stringstream cant convert them to a string(more likely).
	

	//now draw the Time. time is updated/redrawn each frame, regardless of what happends :

   
	//calculate the seconds into minutes and seconds
	int minutes = time_passed / 60;
	int seconds = time_passed % 60;

	//make an array for the minutes and convert minutes to a string
	char minute_count[5];
	stringstream ss4;	
	ss4 << minutes;
	strcpy(minute_count, ss4.str().c_str());

	//same for seconds
	char second_count[5];
	stringstream ss5;	
	ss5 << seconds;
	strcpy(second_count, ss5.str().c_str());
	DrawBG(data.blank_sheet,578,0,35,32);
	message.Draw_Txt(minute_count,578,0,SMALL,LIGHT);

	
	//this is just so it draws a a 0 of the seconds are less then 0, so it doesnt look like this
	// 1:0 or 1:4 but instead  1:00 or 1:04
	
	if(seconds < 10)
	{
		DrawBG(data.blank_sheet,598,0,35,32);
		message.Draw_Txt(":0",598,0,SMALL,LIGHT);
		DrawBG(data.blank_sheet,620,0,35,32);
		message.Draw_Txt(second_count,620,0,SMALL,LIGHT);
	}
	
	else
	{

		DrawBG(data.blank_sheet,598,0,35,32);
		message.Draw_Txt(":",598,0,SMALL,LIGHT);
		DrawBG(data.blank_sheet,608,0,35,32);
		message.Draw_Txt(second_count,608,0,SMALL,LIGHT);
	}



	

	//in the very begining of the board... draw all the non changable items once
	//this is so we dont re-draw text each frame un-needingly so no constant alocating/free of messages.text
	//now this means if this board has been played for less then 1 second
	

		//if the players lives have changed... update/draw the lives
	if(player.lives != old_lives  || time_passed < 1)
	{
	char life_count[2];
	stringstream ss3;	
	ss3 << player.lives;
	strcpy(life_count, ss3.str().c_str());

	DrawBG(data.blank_sheet,438,0,30,32);
	message.Draw_Txt(life_count,438,0,SMALL,LIGHT);
	}


	//lastly lets draw the # of warps left
	if(player.warps != old_warps || time_passed < 1)
	{
	char warp_count[2];
	stringstream ss6;	
	ss6 << player.warps;
	strcpy(warp_count, ss6.str().c_str());

	DrawBG(data.blank_sheet,765,0,30,32);
	message.Draw_Txt(warp_count,765,0,SMALL,LIGHT);
	}

}//end of Draw_Score()

SDL_Surface* Load_Image(char *filename)
{
  SDL_Surface *temp1, *temp2;
  temp1 = IMG_Load(filename);
  temp2 = SDL_DisplayFormat(temp1);
  SDL_FreeSurface(temp1);
  return temp2;
}